# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CloudaccountsvmcIdBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'api_key': 'str',
        'sddc_id': 'str',
        'username': 'str',
        'password': 'str',
        'host_name': 'str',
        'nsx_host_name': 'str',
        'dc_id': 'str',
        'regions': 'list[IaasapicloudaccountsvsphereRegions]',
        'tags': 'list[IaasapistorageprofilesidTags]',
        'create_default_zones': 'bool',
        'accept_self_signed_certificate': 'bool',
        'certificate_info': 'IaasapiintegrationsCertificateInfo',
        'environment': 'str'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'api_key': 'apiKey',
        'sddc_id': 'sddcId',
        'username': 'username',
        'password': 'password',
        'host_name': 'hostName',
        'nsx_host_name': 'nsxHostName',
        'dc_id': 'dcId',
        'regions': 'regions',
        'tags': 'tags',
        'create_default_zones': 'createDefaultZones',
        'accept_self_signed_certificate': 'acceptSelfSignedCertificate',
        'certificate_info': 'certificateInfo',
        'environment': 'environment'
    }

    def __init__(self, name=None, description=None, api_key=None, sddc_id=None, username=None, password=None, host_name=None, nsx_host_name=None, dc_id=None, regions=None, tags=None, create_default_zones=None, accept_self_signed_certificate=None, certificate_info=None, environment=None):  # noqa: E501
        """CloudaccountsvmcIdBody - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._api_key = None
        self._sddc_id = None
        self._username = None
        self._password = None
        self._host_name = None
        self._nsx_host_name = None
        self._dc_id = None
        self._regions = None
        self._tags = None
        self._create_default_zones = None
        self._accept_self_signed_certificate = None
        self._certificate_info = None
        self._environment = None
        self.discriminator = None
        self.name = name
        if description is not None:
            self.description = description
        self.api_key = api_key
        self.sddc_id = sddc_id
        self.username = username
        self.password = password
        self.host_name = host_name
        self.nsx_host_name = nsx_host_name
        self.dc_id = dc_id
        self.regions = regions
        if tags is not None:
            self.tags = tags
        if create_default_zones is not None:
            self.create_default_zones = create_default_zones
        if accept_self_signed_certificate is not None:
            self.accept_self_signed_certificate = accept_self_signed_certificate
        if certificate_info is not None:
            self.certificate_info = certificate_info
        if environment is not None:
            self.environment = environment

    @property
    def name(self):
        """Gets the name of this CloudaccountsvmcIdBody.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :return: The name of this CloudaccountsvmcIdBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CloudaccountsvmcIdBody.

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :param name: The name of this CloudaccountsvmcIdBody.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this CloudaccountsvmcIdBody.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this CloudaccountsvmcIdBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CloudaccountsvmcIdBody.

        A human-friendly description.  # noqa: E501

        :param description: The description of this CloudaccountsvmcIdBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def api_key(self):
        """Gets the api_key of this CloudaccountsvmcIdBody.  # noqa: E501

        VMC API access key. Optional when updating.  # noqa: E501

        :return: The api_key of this CloudaccountsvmcIdBody.  # noqa: E501
        :rtype: str
        """
        return self._api_key

    @api_key.setter
    def api_key(self, api_key):
        """Sets the api_key of this CloudaccountsvmcIdBody.

        VMC API access key. Optional when updating.  # noqa: E501

        :param api_key: The api_key of this CloudaccountsvmcIdBody.  # noqa: E501
        :type: str
        """
        if api_key is None:
            raise ValueError("Invalid value for `api_key`, must not be `None`")  # noqa: E501

        self._api_key = api_key

    @property
    def sddc_id(self):
        """Gets the sddc_id of this CloudaccountsvmcIdBody.  # noqa: E501

        Identifier of the on-premise SDDC to be used by this cloud account. Note that NSX-V SDDCs are not supported.  # noqa: E501

        :return: The sddc_id of this CloudaccountsvmcIdBody.  # noqa: E501
        :rtype: str
        """
        return self._sddc_id

    @sddc_id.setter
    def sddc_id(self, sddc_id):
        """Sets the sddc_id of this CloudaccountsvmcIdBody.

        Identifier of the on-premise SDDC to be used by this cloud account. Note that NSX-V SDDCs are not supported.  # noqa: E501

        :param sddc_id: The sddc_id of this CloudaccountsvmcIdBody.  # noqa: E501
        :type: str
        """
        if sddc_id is None:
            raise ValueError("Invalid value for `sddc_id`, must not be `None`")  # noqa: E501

        self._sddc_id = sddc_id

    @property
    def username(self):
        """Gets the username of this CloudaccountsvmcIdBody.  # noqa: E501

        vCenter user name for the specified SDDC.The specified user requires CloudAdmin credentials. The user does not require CloudGlobalAdmin credentials. Not mandatory for AAP mode.  # noqa: E501

        :return: The username of this CloudaccountsvmcIdBody.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this CloudaccountsvmcIdBody.

        vCenter user name for the specified SDDC.The specified user requires CloudAdmin credentials. The user does not require CloudGlobalAdmin credentials. Not mandatory for AAP mode.  # noqa: E501

        :param username: The username of this CloudaccountsvmcIdBody.  # noqa: E501
        :type: str
        """
        if username is None:
            raise ValueError("Invalid value for `username`, must not be `None`")  # noqa: E501

        self._username = username

    @property
    def password(self):
        """Gets the password of this CloudaccountsvmcIdBody.  # noqa: E501

        Password for the user used to authenticate with the cloud Account. Not mandatory for AAP mode.  # noqa: E501

        :return: The password of this CloudaccountsvmcIdBody.  # noqa: E501
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this CloudaccountsvmcIdBody.

        Password for the user used to authenticate with the cloud Account. Not mandatory for AAP mode.  # noqa: E501

        :param password: The password of this CloudaccountsvmcIdBody.  # noqa: E501
        :type: str
        """
        if password is None:
            raise ValueError("Invalid value for `password`, must not be `None`")  # noqa: E501

        self._password = password

    @property
    def host_name(self):
        """Gets the host_name of this CloudaccountsvmcIdBody.  # noqa: E501

        Enter the IP address or FQDN of the vCenter Server in the specified SDDC. The cloud proxy belongs on this vCenter.  # noqa: E501

        :return: The host_name of this CloudaccountsvmcIdBody.  # noqa: E501
        :rtype: str
        """
        return self._host_name

    @host_name.setter
    def host_name(self, host_name):
        """Sets the host_name of this CloudaccountsvmcIdBody.

        Enter the IP address or FQDN of the vCenter Server in the specified SDDC. The cloud proxy belongs on this vCenter.  # noqa: E501

        :param host_name: The host_name of this CloudaccountsvmcIdBody.  # noqa: E501
        :type: str
        """
        if host_name is None:
            raise ValueError("Invalid value for `host_name`, must not be `None`")  # noqa: E501

        self._host_name = host_name

    @property
    def nsx_host_name(self):
        """Gets the nsx_host_name of this CloudaccountsvmcIdBody.  # noqa: E501

        The IP address of the NSX Manager server in the specified SDDC / FQDN.  # noqa: E501

        :return: The nsx_host_name of this CloudaccountsvmcIdBody.  # noqa: E501
        :rtype: str
        """
        return self._nsx_host_name

    @nsx_host_name.setter
    def nsx_host_name(self, nsx_host_name):
        """Sets the nsx_host_name of this CloudaccountsvmcIdBody.

        The IP address of the NSX Manager server in the specified SDDC / FQDN.  # noqa: E501

        :param nsx_host_name: The nsx_host_name of this CloudaccountsvmcIdBody.  # noqa: E501
        :type: str
        """
        if nsx_host_name is None:
            raise ValueError("Invalid value for `nsx_host_name`, must not be `None`")  # noqa: E501

        self._nsx_host_name = nsx_host_name

    @property
    def dc_id(self):
        """Gets the dc_id of this CloudaccountsvmcIdBody.  # noqa: E501

        Identifier of a data collector vm deployed in the on premise infrastructure. Refer to the data-collector API to create or list data collectors. Not mandatory for AAP mode.  # noqa: E501

        :return: The dc_id of this CloudaccountsvmcIdBody.  # noqa: E501
        :rtype: str
        """
        return self._dc_id

    @dc_id.setter
    def dc_id(self, dc_id):
        """Sets the dc_id of this CloudaccountsvmcIdBody.

        Identifier of a data collector vm deployed in the on premise infrastructure. Refer to the data-collector API to create or list data collectors. Not mandatory for AAP mode.  # noqa: E501

        :param dc_id: The dc_id of this CloudaccountsvmcIdBody.  # noqa: E501
        :type: str
        """
        if dc_id is None:
            raise ValueError("Invalid value for `dc_id`, must not be `None`")  # noqa: E501

        self._dc_id = dc_id

    @property
    def regions(self):
        """Gets the regions of this CloudaccountsvmcIdBody.  # noqa: E501

        A set of regions to enable provisioning on.Refer to /iaas/api/cloud-accounts/region-enumeration.   # noqa: E501

        :return: The regions of this CloudaccountsvmcIdBody.  # noqa: E501
        :rtype: list[IaasapicloudaccountsvsphereRegions]
        """
        return self._regions

    @regions.setter
    def regions(self, regions):
        """Sets the regions of this CloudaccountsvmcIdBody.

        A set of regions to enable provisioning on.Refer to /iaas/api/cloud-accounts/region-enumeration.   # noqa: E501

        :param regions: The regions of this CloudaccountsvmcIdBody.  # noqa: E501
        :type: list[IaasapicloudaccountsvsphereRegions]
        """
        if regions is None:
            raise ValueError("Invalid value for `regions`, must not be `None`")  # noqa: E501

        self._regions = regions

    @property
    def tags(self):
        """Gets the tags of this CloudaccountsvmcIdBody.  # noqa: E501

        A set of tag keys and optional values to set on the Cloud Account.Cloud account capability tags may enable different features.   # noqa: E501

        :return: The tags of this CloudaccountsvmcIdBody.  # noqa: E501
        :rtype: list[IaasapistorageprofilesidTags]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this CloudaccountsvmcIdBody.

        A set of tag keys and optional values to set on the Cloud Account.Cloud account capability tags may enable different features.   # noqa: E501

        :param tags: The tags of this CloudaccountsvmcIdBody.  # noqa: E501
        :type: list[IaasapistorageprofilesidTags]
        """

        self._tags = tags

    @property
    def create_default_zones(self):
        """Gets the create_default_zones of this CloudaccountsvmcIdBody.  # noqa: E501

        Create default cloud zones for the enabled regions.  # noqa: E501

        :return: The create_default_zones of this CloudaccountsvmcIdBody.  # noqa: E501
        :rtype: bool
        """
        return self._create_default_zones

    @create_default_zones.setter
    def create_default_zones(self, create_default_zones):
        """Sets the create_default_zones of this CloudaccountsvmcIdBody.

        Create default cloud zones for the enabled regions.  # noqa: E501

        :param create_default_zones: The create_default_zones of this CloudaccountsvmcIdBody.  # noqa: E501
        :type: bool
        """

        self._create_default_zones = create_default_zones

    @property
    def accept_self_signed_certificate(self):
        """Gets the accept_self_signed_certificate of this CloudaccountsvmcIdBody.  # noqa: E501

        Accept self signed certificate when connecting to vSphere  # noqa: E501

        :return: The accept_self_signed_certificate of this CloudaccountsvmcIdBody.  # noqa: E501
        :rtype: bool
        """
        return self._accept_self_signed_certificate

    @accept_self_signed_certificate.setter
    def accept_self_signed_certificate(self, accept_self_signed_certificate):
        """Sets the accept_self_signed_certificate of this CloudaccountsvmcIdBody.

        Accept self signed certificate when connecting to vSphere  # noqa: E501

        :param accept_self_signed_certificate: The accept_self_signed_certificate of this CloudaccountsvmcIdBody.  # noqa: E501
        :type: bool
        """

        self._accept_self_signed_certificate = accept_self_signed_certificate

    @property
    def certificate_info(self):
        """Gets the certificate_info of this CloudaccountsvmcIdBody.  # noqa: E501


        :return: The certificate_info of this CloudaccountsvmcIdBody.  # noqa: E501
        :rtype: IaasapiintegrationsCertificateInfo
        """
        return self._certificate_info

    @certificate_info.setter
    def certificate_info(self, certificate_info):
        """Sets the certificate_info of this CloudaccountsvmcIdBody.


        :param certificate_info: The certificate_info of this CloudaccountsvmcIdBody.  # noqa: E501
        :type: IaasapiintegrationsCertificateInfo
        """

        self._certificate_info = certificate_info

    @property
    def environment(self):
        """Gets the environment of this CloudaccountsvmcIdBody.  # noqa: E501

        The environment where the agent has been deployed. When the agent has been deployed using the \"Add Ons\" in VMC UI or Api use \"aap\".  # noqa: E501

        :return: The environment of this CloudaccountsvmcIdBody.  # noqa: E501
        :rtype: str
        """
        return self._environment

    @environment.setter
    def environment(self, environment):
        """Sets the environment of this CloudaccountsvmcIdBody.

        The environment where the agent has been deployed. When the agent has been deployed using the \"Add Ons\" in VMC UI or Api use \"aap\".  # noqa: E501

        :param environment: The environment of this CloudaccountsvmcIdBody.  # noqa: E501
        :type: str
        """

        self._environment = environment

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CloudaccountsvmcIdBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CloudaccountsvmcIdBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
